#ifndef __DATATYPE__H_

#define __DATATYPE__H_

// Data type Macro
typedef unsigned char			BYTE;	// 8bit
typedef char					CHAR;
typedef unsigned char			UCHAR;
typedef unsigned short			WORD;	// 16bit
typedef unsigned int			DWORD;	// 32bit
typedef long					LONG;	// 32bit
typedef unsigned long			ULONG;	// 32bit
typedef unsigned long long		QWORD;	// 64bit
typedef unsigned char*			PUCHAR;
typedef unsigned short			WCHAR;

#ifdef __cplusplus
typedef int					BOOL;
#define FALSE				0
#define TRUE				1
#else
	#define false 0
	#define true 1
	#define BOOL	int
#endif

typedef unsigned long*			ULONG_PTR;	
typedef unsigned long*			PLONG;
typedef long*					LONG_PTR;
typedef char*					PCHAR;

#ifndef TRUE 
	#define TRUE true
#endif

#ifndef FALSE
	#define FALSE false
#endif

#define HANDLE	FILE *
#define LPVOID void*

#ifdef __GNUC__
	#define __stdcall __attribute__((stdcall))
	#define __cdecl __attribute__((cdecl))
#endif

#ifdef __GNUC__
#undef NULL
#define NULL 0
#endif

#endif
